﻿@inject ITextTheme _textTheme
@inject IKrakenOptions _options

@if ( FullPage ) {
    <Box Class="@( IsLoading ? "loading-overlay" : "" )">
        <SpinLoader Center="true" Spinner="Spinner" Color="@_textTheme.Secondary" Size="6em" IsLoading="@(IsLoading)">
            <ContentTemplate>
            </ContentTemplate>
        </SpinLoader>
    </Box>
    @if ( !IsLoading )
        @ChildContent
} else {
    <SpinLoader Spinner="SpinnerType.Circle" IsLoading="IsLoading">
        <ContentTemplate>
            @ChildContent
        </ContentTemplate>
        <LoadingTemplate>
            <Box Class="@("loading " + Class)">
                <Box Class="loading-internal">
                    <Circle Color="#e67e22" Size="30px" Center="true" />
                </Box>
            </Box>
        </LoadingTemplate>
    </SpinLoader>
}

@code {
    [Parameter]
    public bool IsLoading { get; set; }

    [Parameter]
    public RenderFragment ChildContent { get; set; }

    [Parameter]
    public string Class { get; set; }

    [Parameter]
    public SpinnerType Spinner { get; set; }

    private bool FullPage { get => ChildContent == null; }

    protected override void OnInitialized( ) {
        Spinner = _options.SpinnerType;
        base.OnInitialized( );
    }
}